import 'package:kubernetes/src/generated/api/policy/v1beta1/pod_disruption_budget.dart';
import 'package:kubernetes/src/generated/apimachinery/pkg/apis/meta/v1/list_meta.dart';

/// PodDisruptionBudgetList is a collection of PodDisruptionBudgets.
class PodDisruptionBudgetList {
  /// The main constructor.
  const PodDisruptionBudgetList({
    this.apiVersion,
    required this.items,
    this.kind,
    this.metadata,
  });

  /// Creates a PodDisruptionBudgetList from JSON data.
  PodDisruptionBudgetList.fromJson(Map<String, dynamic> json)
      : this(
          apiVersion: json['apiVersion'],
          items: json['items'] != null
              ? PodDisruptionBudget.listFromJson(
                  (json['items'] as Iterable).cast<Map<String, dynamic>>())
              : [],
          kind: json['kind'],
          metadata: json['metadata'] != null
              ? ListMeta.fromJson(json['metadata'])
              : null,
        );

  /// Creates a list of PodDisruptionBudgetList from JSON data.
  static List<PodDisruptionBudgetList> listFromJson(
      Iterable<Map<String, dynamic>> list) {
    return list.map((e) => PodDisruptionBudgetList.fromJson(e)).toList();
  }

  /// APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
  final String? apiVersion;

  /// items list individual PodDisruptionBudget objects
  final List<PodDisruptionBudget> items;

  /// Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
  final String? kind;

  /// Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata
  final ListMeta? metadata;
}
